<?php

namespace App\Controller\Admin;

use App\Enum\Role;
use App\Entity\User;
use App\Entity\UserAddress;
use App\Traits\LanguagesTrait;
use App\Entity\RestaurantCategory;
use App\Controller\Admin\CrudController;
use Doctrine\ORM\EntityManagerInterface;
use App\Controller\Admin\Field\VichImageField;
use EasyCorp\Bundle\EasyAdminBundle\Config\Crud;
use EasyCorp\Bundle\EasyAdminBundle\Config\Action;
use EasyCorp\Bundle\EasyAdminBundle\Config\Actions;
use EasyCorp\Bundle\EasyAdminBundle\Config\Filters;
use EasyCorp\Bundle\EasyAdminBundle\Field\FormField;
use EasyCorp\Bundle\EasyAdminBundle\Field\TextField;
use EasyCorp\Bundle\EasyAdminBundle\Field\ChoiceField;
use Symfony\Contracts\Translation\TranslatorInterface;
use EasyCorp\Bundle\EasyAdminBundle\Field\BooleanField;
use EasyCorp\Bundle\EasyAdminBundle\Filter\ChoiceFilter;
use EasyCorp\Bundle\EasyAdminBundle\Context\AdminContext;
use EasyCorp\Bundle\EasyAdminBundle\Field\AssociationField;
use Symfony\Component\Form\Extension\Core\Type\PasswordType;
use EasyCorp\Bundle\EasyAdminBundle\Router\AdminUrlGenerator;
use Symfony\Component\Validator\Validator\ValidatorInterface;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\IsGranted;
use EasyCorp\Bundle\EasyAdminBundle\Provider\AdminContextProvider;
use Symfony\Component\PasswordHasher\Hasher\UserPasswordHasherInterface;
use Symfony\Component\Security\Core\Encoder\UserPasswordEncoderInterface;
use Symfony\Component\DependencyInjection\ParameterBag\ParameterBagInterface;

class RestaurantCategoryCrudController extends CrudController
{
    use LanguagesTrait;

    public function __construct (ParameterBagInterface $params, EntityManagerInterface $em,
                                 AdminContextProvider $context, ValidatorInterface $validator,
                                 TranslatorInterface $translator, AdminUrlGenerator $adminUrlGenerator,
                                 UserPasswordHasherInterface $userPasswordHasher)
    {
        parent::__construct($params, $em, $context, $validator, $translator, $adminUrlGenerator);
    }


    public static function getEntityFqcn (): string
    {
        return RestaurantCategory::class;
    }


    public function configureCrud (Crud $crud): Crud
    {
        return $crud
            ->setEntityLabelInSingular($this->trans('restaurantCategory.labelInSingular'))
            ->setEntityLabelInPlural($this->trans('restaurantCategory.labelInPlural'))
            ->setSearchFields(['name'])
            ;
    }


    public function configureActions (Actions $actions): Actions
    {
        return $actions
            ->add(Crud::PAGE_INDEX, Action::DETAIL);
    }

    public function configureFields (string $pageName): iterable
    {
        $panelInfo = FormField::addPanel($this->trans('restaurantCategory.labelInSingular'));
        $name = TextField::new('name')
            ->setLabel($this->trans('restaurantCategory.configureFields.type'))
            ->setColumns('col-md-6 col-xl-3')
            ->setRequired(true)
        ;

        $isActive = BooleanField::new('isActive')
            ->setLabel($this->trans('restaurantCategory.configureFields.isActive'))
            ->setColumns('col-md-3 col-xl-3')
        ;

        $isPrincipal = BooleanField::new('isPrincipal')
            ->setLabel($this->trans('restaurantCategory.configureFields.isPrincipal'))
            ->setColumns('col-md-3 col-xl-3')
        ;

        $image = VichImageField::new('imageFile')
            ->setLabel($this->trans('restaurantCategory.configureFields.image'));
        // FIXFER no guarda imagen, ni idea porque

        if (in_array($pageName, [Crud::PAGE_INDEX]))
        {
            return [$name, $isActive, $isPrincipal];
        }
        else if (in_array($pageName, [Crud::PAGE_NEW, Crud::PAGE_EDIT, Crud::PAGE_DETAIL]))
        {

            return [
                        $panelInfo,
                        $name,
                        $isActive,
                        $isPrincipal,
                        $image
                    ];
        }

        return [];
    }

}
